﻿using System;
using System.Collections.Generic;
using System.Drawing;

namespace NTERA.Console
{
	public class TextRenderItem : BaseRenderItem
	{
		public Font Font { get; set; } = new Font("MS UI Gothic", 12);

		public SolidBrush TextBrush = new SolidBrush(Color.White);

		public string Text { get; set; }

		public TextRenderItem(string text)
		{
			Text = text;
		}

		public override void Render(Graphics graphics, Rectangle renderArea, Point mousePointer)
		{
			graphics.DrawString(Text, Font, TextBrush, renderArea);
		}

		public static List<TextRenderItem> CreateFromLinedText(string text)
		{
			List<TextRenderItem> items = new List<TextRenderItem>();

			foreach (string line in text.Split("\r\n".ToCharArray(), StringSplitOptions.RemoveEmptyEntries))
			{
				items.Add(new TextRenderItem(line));
			}

			return items;
		}
	}
}