using System;
using System.Drawing;
using System.Runtime.InteropServices;

namespace MinorShift._Library
{
	public enum StretchMode
	{
		STRETCH_ANDSCANS = 1,
		STRETCH_ORSCANS = 2,
		STRETCH_DELETESCANS = 3,
		STRETCH_HALFTONE = 4
	}
	internal static class GDI
	{
		[DllImport("gdi32.dll", ExactSpelling = true, PreserveSig = true, SetLastError = true)]
		public static extern IntPtr SelectObject(IntPtr hdc, IntPtr hgdiobj);
		[DllImport("gdi32.dll")]
		public static extern bool DeleteObject(IntPtr hObject);
        [DllImport("gdi32.dll", CharSet = CharSet.Auto)]
		static extern bool GetTextExtentPoint32(IntPtr hdc, string lpString, int cbString, out Size lpSize);

		[DllImport("user32", EntryPoint = "GetTabbedTextExtent", CharSet = CharSet.Auto)]
        static extern int GetTabbedTextExtentW(IntPtr hdc, string lpString, int nCount, int nTabPositions, ref int lpnTabStopPositions);

		static IntPtr hDC;
		static Font lastFont;
		static IntPtr defaulthFont;
		//static IntPtr defaulthBrush;
		//static IntPtr defaulthPen;
		//static Color lastTextColor;
		//static Color lastBrushColor;
		//static Color lastPenColor;
		static Size fontMetrics;
		static bool usingStockBrush;
		static int devnull;
		//static bool isNt = (System.Environment.OSVersion.Platform == PlatformID.Win32NT) ? true : false;
		static GDI()
		{
			MeasureText = MeasureTextNT;
		}
		public static void GDIStart(Graphics g, Color backGroundColor)
		{
			//hDC = g.GetHdc();
			//IntPtr hBrush = CreateSolidBrush(ColorTranslator.ToWin32(backGroundColor));
			//defaulthBrush = SelectObject(hDC, hBrush);
			//IntPtr hPen = CreatePen(0, 0, ColorTranslator.ToWin32(backGroundColor));
			//defaulthPen = SelectObject(hDC, hPen);
			//SetTextColor(hDC, ColorTranslator.ToWin32(backGroundColor));
			//SetBkColor(hDC, ColorTranslator.ToWin32(backGroundColor));
			//lastFont = null;
			//lastBrushColor = backGroundColor;
			//lastPenColor = backGroundColor;
			//lastTextColor = backGroundColor;
			//usingStockBrush = false;
			//SetStretchBltMode(hDC, StretchMode.STRETCH_DELETESCANS);
		}

		public delegate void DelegateTextOut(string str, int x, int y);
		public delegate void DelegateTextOutFull(Font font, Color color, string str, int x, int y);
		public delegate Size DelegateMeasureText(string str, Font font);
		public static DelegateMeasureText MeasureText;

		#region MesureText用

		static IntPtr hDCMesureText;
		static Font mtLastFont;
		static IntPtr mtDefaulthFont;

		static Size MeasureText98(string str, Font font)
		{
			if (mtLastFont != font)
			{
				IntPtr hFont = font.ToHfont();
				IntPtr hOldFont = SelectObject(hDCMesureText, hFont);
				if (mtLastFont == null)
					mtDefaulthFont = hOldFont;
				else
					DeleteObject(hOldFont);
				mtLastFont = font;
				GetTextExtentPoint32(hDCMesureText, "あ", "あ".Length, out fontMetrics);
			}
			int ret = GetTabbedTextExtentW(hDCMesureText, str, LangManager.GetStrlenLang(str), 0, ref devnull);
			Size size = new Size(ret & 0xffff, (ret >> 16) & 0xffff);
			return size;
		}
		static Size MeasureTextNT(string str, Font font)
		{
			if (mtLastFont != font)
			{
				IntPtr hFont = font.ToHfont();
				IntPtr hOldFont = SelectObject(hDCMesureText, hFont);
				if (mtLastFont == null)
					mtDefaulthFont = hOldFont;
				else
					DeleteObject(hOldFont);
				mtLastFont = font;
				GetTextExtentPoint32(hDCMesureText, "あ", "あ".Length, out fontMetrics);
			}
			int ret = GetTabbedTextExtentW(hDCMesureText, str, str.Length, 0, ref devnull);
			Size size = new Size(ret & 0xffff, (ret >> 16) & 0xffff);
			return size;
		}

		public static void GdiMesureTextStart(Graphics g)
		{
			hDCMesureText = g.GetHdc();
			mtLastFont = null;
		}
		public static void GdiMesureTextEnd(Graphics g)
		{
			if (mtLastFont != null)
				DeleteObject(SelectObject(hDCMesureText, mtDefaulthFont));
			g.ReleaseHdc(hDCMesureText);
			mtLastFont = null;
		}
		#endregion
	}
}